<script lang="ts">
// get the chord def param
// get the scaling

import { defineComponent } from "vue";
import type { PropType } from "vue";
import ChordBarres from "./ChordBarres.vue";
import type { BarreDef } from "./ChordBarres.vue";
import { txDurations, type PositionDef } from "./ChordPosition.vue";
import { PositionType, TxType } from "./ChordPosition.vue";
import ChordPosition from "./ChordPosition.vue";
import type { ChordDefinition } from "@/lib/chordDictionary";

type StringToType = Array<PositionType>;
type ChordPosDef = Map<number, StringToType>;

function calcYOffset(startFret: number, fret: number) {
  return startFret > 0 && fret > 0
    ? 32 - 9 + (fret - (startFret - 1)) * 18
    : 32 - 9 + fret * 18;
}

function typeIsNumbered(type: PositionType) {
  return (
    type === PositionType.Finger1 ||
    type === PositionType.Finger2 ||
    type === PositionType.Finger3 ||
    type === PositionType.Finger4
  );
}

function unshiftOpenFret(chordDef: ChordDefinition) {
  let hasOpenFret = false;
  chordDef.forEach((fret) => {
    if (fret[0] === 0) {
      hasOpenFret = true;
    }
  });
  if (!hasOpenFret) {
    chordDef.unshift([0, 0, 0, 0, 0]);
  }
}

export default defineComponent({
  props: {
    editable: { type: Boolean, default: false },
    initialStartFret: { type: Number, required: true },
    initialChordDef: { type: Object as PropType<ChordDefinition> },
    forceCorrect: { type: Boolean, default: false },
    showNotes: { type: Boolean, default: false },
  },
  data() {
    const chordPosList: Array<PositionDef> = [];
    const positionRefs = new Map<number, Array<any>>();
    const chordPosToType: ChordPosDef = new Map<number, StringToType>();
    const startFret = this.initialStartFret;
    const endFret = startFret === 0 ? 5 : startFret + 4;
    for (let fret = startFret; fret <= endFret; ++fret) {
      // ensure the fretted value is shown before the fret by offsetting it by
      // 9 towards the previous fret
      // calculate the correct relative fret when we're not starting at 0
      const yOffset = calcYOffset(startFret, fret);
      const initialType = fret === 0 ? PositionType.Muted : PositionType.Empty;
      chordPosToType.set(fret, [
        initialType,
        initialType,
        initialType,
        initialType,
      ]);

      // check if this is exists in the initial chord def
      if (this.initialChordDef) {
        this.initialChordDef.forEach((initialFret) => {
          if (initialFret[0] === fret) {
            chordPosToType.set(fret, [
              initialFret[1],
              initialFret[2],
              initialFret[3],
              initialFret[4],
            ]);
          }
        });
      }

      positionRefs.set(fret, [null, null, null, null]);
      for (let stringNo = 0; stringNo < 4; ++stringNo) {
        // co-ordinates of the string
        const xOffset = 10 + stringNo * 18;
        if (fret === 0) {
          chordPosList.push({
            x: xOffset,
            y: yOffset + 2,
            r: 3,
            stringNo,
            fretNo: fret,
          });
        } else {
          chordPosList.push({
            x: xOffset,
            y: yOffset,
            r: 6,
            stringNo,
            fretNo: fret,
          });
        }
      }
    }
    return {
      chordPosList,
      chordPosToType,
      startFret,
      endFret,
      positionRefs,
      other: null,
    };
  },
  emits: {
    onPosUpdate(
      fretNo: number,
      stringNo: number,
      type: PositionType,
      txType: TxType
    ) {
      return true;
    },
  },
  expose: [
    "reset",
    "revealGuess",
    "updatePosition",
    "getChordDef",
    "doRipple",
    "revealQuickly",
  ],
  methods: {
    reset() {
      for (let fret = this.startFret; fret <= this.endFret; ++fret) {
        const posType = fret === 0 ? PositionType.Muted : PositionType.Empty;
        this.setPosition(fret, 0, posType, TxType.None);
        this.setPosition(fret, 1, posType, TxType.None);
        this.setPosition(fret, 2, posType, TxType.None);
        this.setPosition(fret, 3, posType, TxType.None);
      }
    },
    setChordDef(chordDef: ChordDefinition, txType: TxType, done: () => void) {
      unshiftOpenFret(chordDef);
      let delay = 0;
      for (let stringNo = 0; stringNo < 4; ++stringNo) {
        chordDef.forEach((fret) => {
          if (this.getTypeForPos(fret[0], stringNo) !== fret[stringNo + 1]) {
            setTimeout(() => {
              this.updatePosition(
                fret[0],
                stringNo,
                fret[stringNo + 1],
                txType
              );
            }, delay);
            delay += txDurations[txType];
          }
        });
      }
      setTimeout(done, delay);
    },
    revealQuickly(chordDef: ChordDefinition, done: () => void) {
      unshiftOpenFret(chordDef);
      let delay = 0;
      for (let stringNo = 0; stringNo < 4; ++stringNo) {
        chordDef.forEach((fret) => {
          if (this.getTypeForPos(fret[0], stringNo) !== fret[stringNo + 1]) {
            setTimeout(() => {
              this.updatePosition(
                fret[0],
                stringNo,
                fret[stringNo + 1],
                TxType.Flip
              );
            }, delay);
            delay += 70;
          }
        });
      }
      setTimeout(done, txDurations[TxType.Flip] + delay);
    },
    revealGuess(chordDef: ChordDefinition, done: () => void) {
      this.setChordDef(chordDef, TxType.Flip, done);
    },
    doRipple(done: () => void) {
      let delay = 0;
      for (let stringNo = 0; stringNo < 4; ++stringNo) {
        for (let fretNo = this.startFret; fretNo <= this.endFret; ++fretNo) {
          if (this.getTypeForPos(fretNo, stringNo) !== PositionType.Empty) {
            setTimeout(() => {
              const fretRef = this.positionRefs.get(fretNo);
              if (fretRef !== undefined) {
                fretRef[stringNo].doJump();
              } else {
                throw new Error("Invalid fretNo ref");
              }
            }, delay);
            delay += txDurations.Jump / 4;
          }
        }
      }
      setTimeout(done, delay + txDurations.Jump);
    },
    setPosition(
      fretNo: number,
      stringNo: number,
      type: PositionType,
      txType: TxType
    ) {
      try {
        const fret = this.chordPosToType.get(fretNo);
        if (fret !== undefined) {
          fret[stringNo] = type;
        }
        // update child directly, what if this doesn't exist
        const fretRef = this.positionRefs.get(fretNo);
        if (fretRef !== undefined) {
          fretRef[stringNo].setType(type, txType);
        }
      } catch (e) {
        // can happen when mounted with timers running
      }
    },
    updatePosition(
      fretNo: number,
      stringNo: number,
      type: PositionType,
      txType: TxType
    ) {
      this.setPosition(fretNo, stringNo, type, txType);
      this.$emit("onPosUpdate", fretNo, stringNo, type, txType);
    },
    getTypeForPos(fretNo: number, stringNo: number) {
      const fret = this.chordPosToType.get(fretNo);
      if (fret !== undefined) {
        return fret[stringNo];
      } else {
        throw new Error("Invalid fretNo");
      }
    },
    getChordDef() {
      const ret: ChordDefinition = [];
      for (let fret = this.startFret; fret <= this.endFret; ++fret) {
        ret.push([
          fret,
          this.getTypeForPos(fret, 0),
          this.getTypeForPos(fret, 1),
          this.getTypeForPos(fret, 2),
          this.getTypeForPos(fret, 3),
        ]);
      }
      return ret;
    },
    onClick(fretNo: number, stringNo: number, type: PositionType) {
      if (this.editable) {
        const newType =
          type === PositionType.Empty || type == PositionType.Muted
            ? PositionType.Played
            : fretNo === 0
            ? PositionType.Muted
            : PositionType.Empty;
        // unset any other position on the string
        this.chordPosToType.forEach((strings, fret) => {
          if (fret === fretNo) {
            this.updatePosition(fretNo, stringNo, newType, TxType.Click);
          } else if (fret === 0 && newType === PositionType.Empty) {
            if (strings[stringNo] !== PositionType.Muted) {
              this.updatePosition(
                fret,
                stringNo,
                PositionType.Muted,
                TxType.Click
              );
            }
          } else {
            if (strings[stringNo] !== PositionType.Empty) {
              this.updatePosition(
                fret,
                stringNo,
                PositionType.Empty,
                TxType.Click
              );
            }
          }
        });
      }
    },
  },
  components: { ChordBarres, ChordPosition },
  computed: {
    barres() {
      const barres: Array<BarreDef> = [];
      this.chordPosToType.forEach((strings, fret) => {
        const yOffset = calcYOffset(this.startFret, fret);
        // we track these vars to decide when to draw a barre line
        let barreStringStart = -1;
        let barreFinger = PositionType.Empty;
        strings.forEach((type, stringNo) => {
          // barre chords logic
          if (barreStringStart === -1) {
            // nothing started yet, but do start if this is a real finger
            if (typeIsNumbered(type)) {
              barreStringStart = stringNo;
              barreFinger = type;
            }
          } else if (type != barreFinger) {
            // ending a barre, so draw it, must not be open strings and must span
            // more than one string
            if (fret > 0 && stringNo - 1 - barreStringStart >= 1) {
              barres.push({
                startString: barreStringStart,
                endString: stringNo - 1,
                yOffset,
                fret,
              });
            }
            // maintain the barre or start a new one
            if (typeIsNumbered(type)) {
              barreStringStart = stringNo;
              barreFinger = type;
            } else {
              // not a real finger so no barre
              barreStringStart = -1;
              barreFinger = PositionType.Empty;
            }
          }
        });
        // check if we have a barre on the last string and draw it
        if (fret > 0 && barreStringStart != -1 && 3 - barreStringStart >= 1) {
          barres.push({
            startString: barreStringStart,
            endString: 3,
            yOffset,
            fret,
          });
        }
      });
      return barres;
    },
  },
});
</script>
<template>
  <ChordBarres :barres="barres" />
  <ChordPosition
    v-for="(chordPos, key) in chordPosList"
    :key="key"
    :editable="editable"
    :position="chordPos"
    :force-correct="forceCorrect"
    :initial-type="getTypeForPos(chordPos.fretNo, chordPos.stringNo)"
    :show-note="showNotes"
    :ref="
      (el) => {
        const fretRef = positionRefs.get(chordPos.fretNo);
        if (fretRef !== undefined) {
          fretRef[chordPos.stringNo] = el;
        } else {
          throw new Error('Invalid fretNo setting ref');
        }
      }
    "
    @onClick="
      (type) => {
        onClick(chordPos.fretNo, chordPos.stringNo, type);
      }
    "
  />
</template>
